class SavedItem
{
public:
    SavedItem(const char *name) : tag(name) {};
    virtual void read(FILE *f) = 0;
    virtual void write(FILE *f) = 0;
protected:
    const char *tag;
};

class SavedBool : public SavedItem
{
public:
    SavedBool(const char *name, bool *variable)
	: SavedItem(name), var(variable);
    void read(FILE *f);
    void write(FILE *f);
protected:
    bool *var;
};

void SavedBool::read(FILE *f)
{
    *var = (getc(f) == 'Y');
}

void SavedBool::write(FILE *f)
{
    putc(*var ? 'Y' : 'N', f);
}

class SavedInt : public SavedItem
{
public:
    SavedInt(const char *name, int *variable)
	: SavedItem(name), var(variable);
    void read(FILE *f);
    void write(FILE *f);
protected:
    int *var;
};

void SavedInt::read(char *buf)
{
    fscanf(f, "%d", var);
}

void SavedInt::write(FILE *f)
{
    fprintf(f, "%d", *var);
}

class SavedIntSvec : public SavedItem
{
public:
    SavedIntSvec(const char *name, void (Qps::*receiver)(Svec *v), void (Qps::xmitter)(Svec *v))
	: SavedItem(name), recv(receiver);
    void read(FILE *f);
    void write(FILE *f);
protected:
    void (Qps::*recv)(Svec *v);
};

void SavedIntSvec::read(FILE *f)
{
    
}
